# remirepo/fedora spec file for php-herrera-io-phar-update
#
# Copyright (c) 2015 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global gh_commit    15643c90d3d43620a4f45c910e6afb7a0ad4b488
#global gh_date      20150728
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     kherge-abandoned
%global gh_project   php-phar-update
%global php_home     %{_datadir}/php
%global ns_vendor    Herrera
%global ns_project   Phar/Update
%global c_vendor     herrera-io
%global c_project    phar-update
%global with_tests   0%{!?_without_tests:1}

Name:           php-%{c_vendor}-%{c_project}
Version:        2.0.0
%global specrel 1
Release:        %{?gh_date:0.%{specrel}.%{?prever}%{!?prever:%{gh_date}git%{gh_short}}}%{!?gh_date:%{specrel}}%{?dist}
Summary:        A library for self-updating Phars

Group:          Development/Libraries
License:        MIT
URL:            https://github.com/%{gh_owner}/%{gh_project}
Source0:        https://github.com/%{gh_owner}/%{gh_project}/archive/%{gh_commit}/%{gh_project}-%{version}-%{gh_short}.tar.gz

Source1:        %{name}-autoload.php

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
%if %{with_tests}
BuildRequires:  php(language) >= 5.3.3
BuildRequires:  php-phar
BuildRequires:  php-spl
BuildRequires:  php-composer(%{c_vendor}/json) >= 1.0
BuildRequires:  php-composer(%{c_vendor}/version) >= 1.0
# From composer.json, "require-dev": {
#        "herrera-io/phpunit-test-case": "1.*",
#        "mikey179/vfsStream": "1.1.0",
#        "phpunit/phpunit": "3.7.*"
BuildRequires:  php-composer(%{c_vendor}/phpunit-test-case) >= 1
BuildRequires:  php-composer(mikey179/vfsStream) >= 1.1.0
BuildRequires:  php-composer(phpunit/phpunit) >= 3.7
# Autoloader
BuildRequires:  php-composer(symfony/class-loader)
%endif

# from composer.json, "require": {
#        "php": ">=5.3.3",
#        "herrera-io/json": "1.*",
#        "herrera-io/version": "1.*"
Requires:       php(language) >= 5.3.3
Requires:       php-composer(%{c_vendor}/json) >= 1.0
Requires:       php-composer(%{c_vendor}/json) <  2
Requires:       php-composer(%{c_vendor}/version) >= 1.0
Requires:       php-composer(%{c_vendor}/version) <  2
# Autoloader
Requires:       php-composer(symfony/class-loader)
# from phpcompatinfo report for version 2.0.0
Requires:       php-phar
Requires:       php-spl

Provides:       php-composer(%{c_vendor}/%{c_project}) = %{version}


%description
%{summary}.

This library handles the updating of applications packaged as
distributable Phars. The modular design allows for a more
customizable update process.

To use this library, you just have to add, in your project:
  require_once '%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';


%prep
%setup -q -n %{gh_project}-%{gh_commit}

cp %{SOURCE1} src/lib/%{ns_vendor}/%{ns_project}/autoload.php


%build
# Empty


%install
rm -rf                      %{buildroot}
mkdir -p                    %{buildroot}%{php_home}
cp -pr src/lib/%{ns_vendor} %{buildroot}%{php_home}/%{ns_vendor}
# yes, ugly
cp res/schema.json            %{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}/

%check
%if %{with_tests}
cat << 'EOF' | tee src/tests/bootstrap.php
<?php
// This library
require_once '%{buildroot}%{php_home}/%{ns_vendor}/%{ns_project}/autoload.php';
// Dependencies
require_once '%{php_home}/%{ns_vendor}/PHPUnit/autoload.php';
require_once '%{php_home}/org/bovigo/vfs/autoload.php';
// From old bootstrap
org\bovigo\vfs\vfsStreamWrapper::register();
EOF

: Ignore test failing, under investigation
sed -e 's/testDeleteFileUnlinkError/skipDeleteFileUnlinkError/' \
    -i src/tests/Herrera/Phar/Update/UpdateTest.php

%{_bindir}/php -d phar.readonly=0 \
%{_bindir}/phpunit \
   --verbose
%else
: test suite disabled
%endif


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc README.md
%doc composer.json
%dir %{php_home}/%{ns_vendor}/Phar
     %{php_home}/%{ns_vendor}/%{ns_project}


%changelog
* Wed Oct 21 2015 Remi Collet <remi@fedoraproject.org> - 1.0.3-1
- initial package